# ----------------------------------------------------------------------------------------------------------
# autor: Dominik Vladar
# orion login: vladar21
# e-mail: vladar21@students.zcu.cz
#
# Program implementuje funkcionalitu algoritmu quick sort,
# diky cemuz umoznuje efektivne radit ciselne seznamy (zadani ze 4. cviceni, 1. cast).
# ----------------------------------------------------------------------------------------------------------

# Spusti nad predanym seznamem algoritmus quick sort. Vraci serazene pole.
def quick_sort(array):
    if len(array) <= 1:
        return array
    pivot = array[0]  # je vlastne jedno, na jake pozici pivot vybereme
    left = [l for l in array if l < pivot]
    right = [r for r in array if r > pivot]
    return quick_sort(left) + [pivot] + quick_sort(right)


# Spusteni programu. Zde se definuje neserazeny seznam, nad kterym je
# pote volana funkce quick_sort.
if __name__ == '__main__':
    unsorted_arr = [20, 5, 4, 90, -6, 10]
    sorted_arr = quick_sort(unsorted_arr)
    print("Neserazeny seznam: {}.".format(unsorted_arr))
    print("Serazeny seznam: {}.".format(sorted_arr))
    input("Ukoncete stiskem klavesy ENTER.")
