"""
@author Vitaliy Bohera
@version 1
@info Implementace algoritmu Eratosthenova sita pro hledani prvocisel
"""


# funkce vypise vsechna prvocisla az do zadane hodnoty n
def printPrimeNumbers(n):
    # (1 na pozici i = je prvocislo, 0 na pozici i = neni prvocislo)
    # 0 a 1 nejsou povazovana za prvocisla, zbytek nastavim na 1
    array = [0, 0] + [1]*(n-1)

    for i in range(2, n + 1):
        if array[i] == 0:   # pokud prvek neni prvocislo tak jdeme dal
            continue
        for j in range(2*i, n+1, i):  # pokud prvek je prvocislo tak vyhazeme z pole jeho nasobky(nastavime na pozici 0)
            array[j] = 0

    for i in range(2, len(array)):  # projedem pole a kde je nastavena 1 tak index nam udava prvocislo
        if array[i] == 1:
            print(i)


# funkce se zepta uzivatele na horni mez prvocisel a vypise dana prvocisla
def main():
    n = int(input("Zadej horní mez prvočísel: "))
    printPrimeNumbers(n)


if __name__ == '__main__':
    main()

