
'''
Funkce dostane pole integeru a pomoci rekurzivniho quicksort ho seradi
arr - pole integeru, ktere se bude radit
return - serazene pole
'''
def quicksort(arr):
    if len(arr) <= 1:
        return arr  # Ukoncovaci podminka (arr uz je serazen)

    pivot = arr[len(arr) // 2]
    left = [x for x in arr if x < pivot]  # cisla mensi nez pivot
    middle = [x for x in arr if x == pivot]  # cisla stejna jako pivot
    right = [x for x in arr if x > pivot]  # cisla vetsi nez pivot

    return quicksort(left) + middle + quicksort(right)  # rekurzivni volani na levou a pravou cast


print("Program Quicksort - umoznuje rucni zadani seznamu celych cisel a vypisuje tento seznam jako serazeny")

int_array = [int(x) for x in input("Zadejte seznam celych cisel (cisla oddelte mezerami)\n>").split()]
print("Zadany seznam vypada takto:")
print(int_array)
sorted_arr = quicksort(int_array)
print("Serazeny seznam vypada takto:")
print(sorted_arr)

input()
