"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-10-23
Program: Program vypise vsechny prvocisla mensi nebo rovno zadanemu cislu
Verze: 1.0.0
"""

# funkce eratosthenea
import eratosthenes as er

# hlavni beh programu
if __name__ == "__main__":
    # vstup------------------------------------------------------
    my_input = input("Zadej prirozene cislo:\n>")
    # bude zadat o vstup dokud nebude prirozene cislo
    while not my_input.isdigit():
        print("Zadane cislo nebylo prirozene")
        my_input = input("Zadej prirozene cislo:\n>")
    # najde prvocisla--------------------------------------------
    primes = er.eratosthenes(int(my_input))
    # vypis------------------------------------------------------
    print("Prvocisla mensi nebo rovna " + my_input + " jsou:")
    print(str(primes).removesuffix("]").removeprefix("["))
    input("Pro ukonceni programu stiskni ENTER")
