"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-10-21
Program: Knihovna s funkci quicksortu
Verze: 1.0.0
"""

import random

# seradi pole
def quicksort(array):
    # ukoncovaci podminka
    if len(array) <= 1:
        return array

    # hodnota pole podle ktere ho rozdelime na levou a pravou cast
    pivot = array[random.randint(0, len(array) - 1)]
    # leva cast pole podle pivotu
    left = []
    # stejne hodnoty pole jako pivot
    middle = []
    # prava cast pole podle pivotu
    right = []

    # prochazeni polem a rozdelovani na pravou a levou cast
    for x in range (len(array)):
        # hodnota mensi nez pivot do leve casti
        if array[x] < pivot:
            left.append(array[x])
        # hodnota vetsi nez pivot do prave casti
        elif array[x] > pivot:
            right.append(array[x])
        # stejna hodnota jako pivot
        else:
            middle.append(array[x])

    return quicksort(left) + middle + quicksort(right)
