# autor: Miroslav Martinek
# eratosthenova sita, 2 zadani 4 cviceni
from math import sqrt


# najde a vypise vsechny prvocisla <= nez number
def eratosthen(number):
    result = "prvocisla <= " + str(number) + ": 2"
    candidates = [*range(3, number + 1, 2)]  # list lichich cisel <= nez number
    # vsechny prvocisla nalezeny kdyz list kandidatu je prazdny
    while (len(candidates) > 0):
        prime = candidates[0]
        result = result + ", " + str(prime)  # prvocislo vyjmuto z kandidatu a pridano do vysledku
        for x in candidates:
            if (x % prime == 0):
                candidates.remove(x)  # odstraneni nasobku vyjmuteho prvocisla
    print(result)


# vstup
user_input = input("zadejte cislo N pro algoritmus Eratosthenovy site: ")
if (user_input.isnumeric()):
    eratosthen(int(user_input))
else:
    print("neplatny vstup (vstup musi byt cele cislo)")
